Index: java/main/src/main/java/com/framsticks/leftovers/FavouritesXMLFactory.java
===================================================================
--- java/main/src/main/java/com/framsticks/leftovers/FavouritesXMLFactory.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/leftovers/FavouritesXMLFactory.java	(revision 85)
@@ -3,9 +3,11 @@
 import java.io.BufferedWriter;
 import java.io.File;
-import java.io.FileWriter;
+import java.io.FileOutputStream;
+import java.io.IOException;
+import java.io.OutputStreamWriter;
+import java.nio.file.Files;
 import java.util.ArrayList;
 import java.util.Collection;
 import java.util.HashMap;
-import java.util.Iterator;
 import java.util.LinkedHashMap;
 import java.util.Map;
@@ -13,17 +15,94 @@
 import javax.xml.parsers.DocumentBuilder;
 import javax.xml.parsers.DocumentBuilderFactory;
+import javax.xml.parsers.ParserConfigurationException;
 import javax.xml.stream.XMLOutputFactory;
+import javax.xml.stream.XMLStreamException;
 import javax.xml.stream.XMLStreamWriter;
 
+import org.apache.log4j.Logger;
 import org.w3c.dom.Document;
 import org.w3c.dom.Node;
 import org.w3c.dom.NodeList;
+import org.xml.sax.SAXException;
+
+import com.framsticks.util.io.Encoding;
 
 public class FavouritesXMLFactory {
-
-	private final String pathMark = "path";
-	private final String nameMark = "name";
-	private final String fieldMark = "field";
-	private final String typeMark = "type";
+	private static final Logger log = Logger
+			.getLogger(FavouritesXMLFactory.class);
+
+	private static final String PATH_MARK = "path";
+	private static final String NAME_MARK = "name";
+	private static final String FIELD_MARK = "field";
+	private static final String TYPE_MARK = "type";
+
+	protected Node readDocument(String filename) {
+		File file = new File(filename);
+		if (!file.exists()) {
+			return null;
+		}
+		DocumentBuilderFactory docBuilderFactory = DocumentBuilderFactory
+				.newInstance();
+		try {
+			DocumentBuilder docBuilder = docBuilderFactory.newDocumentBuilder();
+			Document doc = docBuilder.parse(file);
+			doc.getDocumentElement().normalize();
+			return doc.getFirstChild();
+
+		} catch (ParserConfigurationException | SAXException | IOException e) {
+			log.error(e);
+			return null;
+		}
+	}
+
+	public static class XmlWriter implements AutoCloseable {
+
+		BufferedWriter writer = null;
+		XMLStreamWriter xml = null;
+
+		public XmlWriter(String filename) throws XMLStreamException,
+				IOException {
+			XMLOutputFactory factory = XMLOutputFactory.newInstance();
+
+			File file = new File(filename);
+			Files.deleteIfExists(file.toPath());
+
+			writer = new BufferedWriter(new OutputStreamWriter(
+					new FileOutputStream(file),
+					Encoding.getDefaultCharset()));
+			xml = factory.createXMLStreamWriter(writer);
+
+			xml.writeStartDocument("1.0");
+		}
+
+		public void close() {
+			try {
+				xml.writeEndDocument();
+				xml.flush();
+				xml.close();
+				writer.close();
+			} catch (XMLStreamException | IOException e) {
+				log.error(e);
+			}
+		}
+
+		public void start(String name) throws XMLStreamException {
+			xml.writeStartElement(name);
+		}
+
+		public void element(String name, Object value) throws XMLStreamException {
+			start(name);
+			xml.writeCharacters(value.toString());
+			end();
+		}
+
+		public void end() throws XMLStreamException {
+			xml.writeEndElement();
+		}
+
+		public void attribute(String name, Object value) throws XMLStreamException {
+			xml.writeAttribute(name, value.toString());
+		}
+	}
 
 	/**
@@ -39,26 +118,12 @@
 			return;
 		}
-		XMLOutputFactory factory = XMLOutputFactory.newInstance();
-		BufferedWriter writer = null;
-		XMLStreamWriter xmlWriter = null;
-		try {
-			File file = new File(path);
-			if (file.exists()) {
-				file.delete();
-			}
-			writer = new BufferedWriter(new FileWriter(file));
-			xmlWriter = factory.createXMLStreamWriter(writer);
-			xmlWriter.writeStartDocument("1.0");
-			xmlWriter.writeStartElement("root");
+
+		try (XmlWriter xml = new XmlWriter(path)) {
+			xml.start("framsticks");
 			for (UserFavourite node : nodes) {
-				xmlWriter.writeStartElement("item");
-
-				xmlWriter.writeStartElement(pathMark);
-				xmlWriter.writeCharacters(node.getPath());
-				xmlWriter.writeEndElement();
-
-				xmlWriter.writeStartElement(nameMark);
-				xmlWriter.writeCharacters(node.getName());
-				xmlWriter.writeEndElement();
+				xml.start("item");
+
+				xml.element(PATH_MARK, node.getPath());
+				xml.element(NAME_MARK, node.getName());
 
 				/*if(node.isFavouriteNode()){
@@ -67,21 +132,10 @@
 					xmlWriter.writeEndElement();
 				}else{ //isFavouriteField() */
-					xmlWriter.writeStartElement(fieldMark);
-					xmlWriter.writeCharacters(node.getField());
-					xmlWriter.writeEndElement();
-				//}
-
-				xmlWriter.writeEndElement();
-			}
-
-			xmlWriter.writeEndDocument();
-			xmlWriter.flush();
-		} catch (Exception e) {
-		} finally {
-			try {
-				xmlWriter.close();
-				writer.close();
-			} catch (Exception e) {
-			}
+				xml.element(FIELD_MARK, node.getField());
+				xml.end();
+			}
+			xml.end();
+		} catch (XMLStreamException | IOException e) {
+			log.error(e);
 		}
 	}
@@ -95,49 +149,41 @@
 	 *         concatenation of path and field getName.
 	 */
-	public LinkedHashMap<String, UserFavourite> readFavouritesXML(String filePath) {
+	public LinkedHashMap<String, UserFavourite> readFavouritesXML(
+			String filePath) {
+
+		Node root = readDocument(filePath);
+		if (root == null) {
+			return null;
+		}
 		LinkedHashMap<String, UserFavourite> result = new LinkedHashMap<String, UserFavourite>();
 
-		File file = new File(filePath);
-		if (file.exists()) {
-			DocumentBuilderFactory docBuilderFactory = DocumentBuilderFactory
-					.newInstance();
-			try {
-				DocumentBuilder docBuilder = docBuilderFactory
-						.newDocumentBuilder();
-				Document doc = docBuilder.parse(file);
-				doc.getDocumentElement().normalize();
-				Node root = doc.getFirstChild();
-				NodeList items = root.getChildNodes();
-				UserFavourite userNode;
-				String path, name, field;
-				for (int i = 0; i < items.getLength(); i++) {
-					Node item = items.item(i);
-					NodeList itemDetails = item.getChildNodes();
-					if (itemDetails.getLength() == 3) {
-						if (itemDetails.item(0).getNodeName().equals(pathMark)
-								&& itemDetails.item(1).getNodeName().equals(nameMark)
-								&& (itemDetails.item(2).getNodeName().equals(fieldMark)
-										|| itemDetails.item(2).getNodeName().equals(typeMark))) {
-							path = itemDetails.item(0).getTextContent();
-							name = itemDetails.item(1).getTextContent();
-							if (itemDetails.item(2).getNodeName().equals(
-									fieldMark)) {
-								field = itemDetails.item(2).getTextContent();
-								userNode = new UserFavourite(path, name, field);
-								result.put(path+field, userNode);
-							}else{
-								try {
-									// int nodeTypeId = Integer.parseInt(itemDetails.item(2).getTextContent());
-									userNode = new UserFavourite(path, name, null);
-									result.put(path, userNode);
-								} catch (Exception e) {
-								}
-							}
+		NodeList items = root.getChildNodes();
+		UserFavourite userNode;
+		String path, name, field;
+		for (int i = 0; i < items.getLength(); i++) {
+			Node item = items.item(i);
+			NodeList itemDetails = item.getChildNodes();
+			if (itemDetails.getLength() == 3) {
+				if (itemDetails.item(0).getNodeName().equals(PATH_MARK)
+						&& itemDetails.item(1).getNodeName().equals(NAME_MARK)
+						&& (itemDetails.item(2).getNodeName().equals(FIELD_MARK)
+								|| itemDetails.item(2).getNodeName().equals(TYPE_MARK))) {
+					path = itemDetails.item(0).getTextContent();
+					name = itemDetails.item(1).getTextContent();
+					if (itemDetails.item(2).getNodeName().equals(
+							FIELD_MARK)) {
+						field = itemDetails.item(2).getTextContent();
+						userNode = new UserFavourite(path, name, field);
+						result.put(path+field, userNode);
+					}else{
+						try {
+							// int nodeTypeId = Integer.parseInt(itemDetails.item(2).getTextContent());
+							userNode = new UserFavourite(path, name, null);
+							result.put(path, userNode);
+						} catch (Exception e) {
 						}
 					}
 				}
-			} catch (Exception e) {
-			}
-
+			}
 		}
 
@@ -159,46 +205,17 @@
 			return;
 		}
-		XMLOutputFactory factory = XMLOutputFactory.newInstance();
-		BufferedWriter writer = null;
-		XMLStreamWriter xmlWriter = null;
-		try {
-			File file = new File(path);
-			if (file.exists()) {
-				file.delete();
-			}
-			writer = new BufferedWriter(new FileWriter(file));
-			xmlWriter = factory.createXMLStreamWriter(writer);
-			xmlWriter.writeStartDocument("1.0");
-			xmlWriter.writeStartElement("root");
-
-			Iterator<String> iterator = groupColumns.keySet().iterator();
-			while (iterator.hasNext()) {
-				/*
-	  Definition of read/write mark.
-	 */
-				String itemMark = "item";
-				xmlWriter.writeStartElement(itemMark);
-				String itemPath = iterator.next();
-				xmlWriter.writeAttribute(pathMark, itemPath);
-
-				for (String column : groupColumns.get(itemPath)) {
-					String columnMark = "column";
-					xmlWriter.writeStartElement(columnMark);
-					xmlWriter.writeCharacters(column);
-					xmlWriter.writeEndElement();
+		try (XmlWriter xml = new XmlWriter(path)) {
+			xml.start("framsticks");
+			for (Map.Entry<String, ArrayList<String>> i : groupColumns.entrySet()) {
+				xml.start("item");
+				xml.attribute(PATH_MARK, i.getKey());
+				for (String column : i.getValue()) {
+					xml.element("column", column);
 				}
-
-				xmlWriter.writeEndElement();
-			}
-
-			xmlWriter.writeEndDocument();
-			xmlWriter.flush();
-		} catch (Exception e) {
-		} finally {
-			try {
-				xmlWriter.close();
-				writer.close();
-			} catch (Exception e) {
-			}
+				xml.end();
+			}
+			xml.end();
+		} catch (XMLStreamException | IOException e) {
+			log.error(e);
 		}
 	}
@@ -214,35 +231,25 @@
 	public HashMap<String, ArrayList<String>> readColumnConfigurationXML(
 			String path) {
+		Node root = readDocument(path);
+		if (root == null) {
+			return null;
+		}
+
 		HashMap<String, ArrayList<String>> result = new LinkedHashMap<String, ArrayList<String>>();
 
-		File file = new File(path);
-		if (file.exists()) {
-			DocumentBuilderFactory docBuilderFactory = DocumentBuilderFactory
-					.newInstance();
-			try {
-				DocumentBuilder docBuilder = docBuilderFactory
-						.newDocumentBuilder();
-				Document doc = docBuilder.parse(file);
-				doc.getDocumentElement().normalize();
-				Node root = doc.getFirstChild();
-				NodeList items = root.getChildNodes();
-				String itemPath;
-				ArrayList<String> columns;
-				for (int i = 0; i < items.getLength(); i++) {
-					Node item = items.item(i);
-					itemPath = item.getAttributes().getNamedItem(pathMark)
-							.getNodeValue();
-					columns = new ArrayList<String>();
-					NodeList itemDetails = item.getChildNodes();
-					for (int j = 0; j < itemDetails.getLength(); j++) {
-						columns.add(itemDetails.item(j).getTextContent());
-					}
-					result.put(itemPath, columns);
-				}
-			} catch (Exception e) {
-			}
-
-		}
-
+		NodeList items = root.getChildNodes();
+		String itemPath;
+		ArrayList<String> columns;
+		for (int i = 0; i < items.getLength(); i++) {
+			Node item = items.item(i);
+			itemPath = item.getAttributes().getNamedItem(PATH_MARK)
+					.getNodeValue();
+			columns = new ArrayList<String>();
+			NodeList itemDetails = item.getChildNodes();
+			for (int j = 0; j < itemDetails.getLength(); j++) {
+				columns.add(itemDetails.item(j).getTextContent());
+			}
+			result.put(itemPath, columns);
+		}
 		return result;
 	}
Index: java/main/src/main/java/com/framsticks/leftovers/f0/NeuroClass.java
===================================================================
--- java/main/src/main/java/com/framsticks/leftovers/f0/NeuroClass.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/leftovers/f0/NeuroClass.java	(revision 85)
@@ -16,7 +16,7 @@
 
 	/**
-	 * The symbol glymph.
-	 */
-	private int[] symbolGlymph;
+	 * The symbol glyph.
+	 */
+	private int[] symbolGlyph;
 
 	/**
@@ -71,10 +71,9 @@
 	 * @param prefLocation the pref location
 	 * @param visualHints  the visual hints
-	 * @param symbolGlymph the symbol glymph
+	 * @param symbolGlyph the symbol glymph
 	 */
 	public NeuroClass(FramsClass framsClass, int prefInputs,
 					  int prefOutput, int prefLocation, int visualHints,
-					  int[] symbolGlymph) {
-		super();
+					  int[] symbolGlyph) {
 		this.framsClass = framsClass;
 		this.prefInputs = prefInputs;
@@ -82,5 +81,5 @@
 		this.prefLocation = prefLocation;
 		this.visualHints = visualHints;
-		this.symbolGlymph = symbolGlymph;
+		this.symbolGlyph = (symbolGlyph == null ? null : Arrays.copyOf(symbolGlyph, symbolGlyph.length));
 	}
 
@@ -153,5 +152,5 @@
 	 */
 	int[] getSymbolGlyph() {
-		return symbolGlymph;
+		return symbolGlyph;
 	}
 
@@ -165,5 +164,5 @@
 	 */
 	void setSymbolGlyph(int[] data) {
-		symbolGlymph = data;
+		symbolGlyph = data;
 	}
 
@@ -191,5 +190,5 @@
 				.append(", prefLocation=").append(prefLocation)
 				.append(", visualHints=").append(visualHints)
-				.append(", symbolGlymph=").append(Arrays.toString(symbolGlymph));
+				.append(", symbolGlymph=").append(Arrays.toString(symbolGlyph));
 
 		sb.append(", paramList={");
Index: java/main/src/main/java/com/framsticks/observers/Endpoint.java
===================================================================
--- java/main/src/main/java/com/framsticks/observers/Endpoint.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/observers/Endpoint.java	(revision 85)
@@ -8,9 +8,10 @@
 import com.framsticks.util.dispatching.Dispatcher;
 import org.apache.log4j.Logger;
+import com.framsticks.util.dispatching.RunAt;
 
 /**
  * @author Piotr Sniegowski
  */
-public class Endpoint implements Dispatcher, InstanceListener {
+public class Endpoint implements Dispatcher<Instance>, InstanceListener {
 	private final static Logger log = Logger.getLogger(Endpoint.class.getName());
 
@@ -67,5 +68,5 @@
 
 	@Override
-	public final void invokeLater(Runnable runnable) {
+	public final void invokeLater(RunAt<? extends Instance> runnable) {
 		instance.invokeLater(runnable);
 	}
Index: java/main/src/main/java/com/framsticks/params/ArrayListAccess.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/ArrayListAccess.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/params/ArrayListAccess.java	(revision 85)
@@ -31,5 +31,5 @@
 	@Override
 	public Param getParam(int i) {
-		return new ParamBuilder().setId(Integer.toString(i)).setName(elementAccess.getId()).setType("o " + elementAccess.getId()).build();
+		return Param.build().id(Integer.toString(i)).name(elementAccess.getId()).type("o " + elementAccess.getId()).finish();
 	}
 
Index: java/main/src/main/java/com/framsticks/params/Flags.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/Flags.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/params/Flags.java	(revision 85)
@@ -60,7 +60,5 @@
 				}
 			}
-		} catch (IllegalArgumentException e) {
-			e.printStackTrace();
-		} catch (IllegalAccessException e) {
+		} catch (IllegalArgumentException | IllegalAccessException e) {
 			e.printStackTrace();
 		}
@@ -80,9 +78,5 @@
 				} catch (SecurityException e) {
 					log.warn("security exception was thrown while trying to read flag (" + flag + ")");
-				} catch (NoSuchFieldException e) {
-					log.warn("selected flag is not known (" + flag + ")");
-				} catch (IllegalArgumentException e) {
-					log.warn("selected flag is not known (" + flag + ")");
-				} catch (IllegalAccessException e) {
+				} catch (NoSuchFieldException | IllegalArgumentException | IllegalAccessException e) {
 					log.warn("selected flag is not known (" + flag + ")");
 				}
Index: java/main/src/main/java/com/framsticks/params/FramsClass.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/FramsClass.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/params/FramsClass.java	(revision 85)
@@ -26,9 +26,10 @@
 public final class FramsClass {
 
-	private final static Logger log = Logger.getLogger(FramsClass.class.getName());
-
-	/**
-	  * The Class which represents group.
-	  */
+	private final static Logger log = Logger.getLogger(FramsClass.class
+			.getName());
+
+	/**
+	 * The Class which represents group.
+	 */
 
 	/** The offset of the parameter (applied for newly added parameter). */
@@ -91,4 +92,8 @@
 	}
 
+	public FramsClass append(ParamBuilder builder) {
+		return append(builder.finish());
+	}
+
 	/**
 	 * Adds new group.
@@ -185,7 +190,7 @@
 	public static FramsClass getFramsClass() {
 		return new FramsClass("class", "class", null)
-			.append(new ParamBuilder().setId("name").setName("Name").setType(StringParam.class).build())
-			.append(new ParamBuilder().setId("id").setName("id").setType(StringParam.class).build())
-			.append(new ParamBuilder().setId("desc").setName("Description").setType(StringParam.class).build());
+			.append(Param.build().id("name").name("Name").type(StringParam.class))
+			.append(Param.build().id("id").name("id").type(StringParam.class))
+			.append(Param.build().id("desc").name("Description").type(StringParam.class));
 	}
 
@@ -210,5 +215,6 @@
 				//TODO uid should be passed along during construction
 				if (containedType instanceof Class) {
-					return "l " + ((Class<?>) containedType).getCanonicalName() + " name";
+					return "l " + ((Class<?>) containedType).getCanonicalName()
+							+ " name";
 				}
 			}
@@ -248,10 +254,14 @@
 
 		public Constructor(Class<?> src, String name) {
-			result = new FramsClass(name, name, GENERATE_HELP_PREFIX + src.toString());
+			result = new FramsClass(name, name, GENERATE_HELP_PREFIX
+					+ src.toString());
 			currentClass = src;
 			while (currentClass != null) {
 				try {
 					currentClass.getMethod("constructFramsClass", Constructor.class).invoke(null, this);
-				} catch (Exception ignored) {
+				} catch (IllegalAccessException | IllegalArgumentException
+						| InvocationTargetException | NoSuchMethodException
+						| SecurityException e) {
+					log.debug("failed to use constructFramsClass static method (skipping): ", e);
 				}
 				currentClass = currentClass.getSuperclass();
@@ -285,5 +295,5 @@
 					if (method.getName().startsWith("get")) {
 						String fieldName = method.getName().substring(3, 4).toLowerCase() + method.getName().substring(4);
-						Param param = new ParamBuilder().setType(returnParamClass).setName(fieldName).setId(fieldName).setHelp(GENERATE_HELP_PREFIX + method.toString()).build();
+						Param param = Param.build().type(returnParamClass).name(fieldName).id(fieldName).help(GENERATE_HELP_PREFIX + method.toString()).finish();
 						assert param != null;
 						result.append(param);
@@ -308,5 +318,5 @@
 					return this;
 				}
-				Param param = new ParamBuilder().setType(paramClass).setName(field.getName()).setId(field.getName()).setHelp(GENERATE_HELP_PREFIX + field.toString()).build();
+				Param param = Param.build().type(paramClass).name(field.getName()).id(field.getName()).help(GENERATE_HELP_PREFIX + field.toString()).finish();
 				assert param != null;
 				result.append(param);
Index: java/main/src/main/java/com/framsticks/params/Param.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/Param.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/params/Param.java	(revision 85)
@@ -105,9 +105,13 @@
 	public static FramsClass getFramsClass() {
 		return new FramsClass("prop", "prop", null)
-				.append(new ParamBuilder().setId("name").setName("Name").setType(StringParam.class).build())
-				.append(new ParamBuilder().setId("id").setName("Id").setType(StringParam.class).build())
-				.append(new ParamBuilder().setId("type").setName("Type").setType(StringParam.class).build())
-				.append(new ParamBuilder().setId("help").setName("Help").setType(StringParam.class).build())
-				.append(new ParamBuilder().setId("flags").setName("Flags").setType(DecimalParam.class).build());
+			.append(Param.build().id("name").name("Name").type(StringParam.class).finish())
+			.append(Param.build().id("id").name("Id").type(StringParam.class).finish())
+			.append(Param.build().id("type").name("Type").type(StringParam.class).finish())
+			.append(Param.build().id("help").name("Help").type(StringParam.class).finish())
+			.append(Param.build().id("flags").name("Flags").type(DecimalParam.class).finish());
+	}
+
+	public static ParamBuilder build() {
+		return new ParamBuilder();
 	}
 
Index: java/main/src/main/java/com/framsticks/params/ParamBuilder.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/ParamBuilder.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/params/ParamBuilder.java	(revision 85)
@@ -55,4 +55,7 @@
 	private PrimitiveParam primitiveParam;
 
+	ParamBuilder() {
+	}
+
 	/**
 	 * Build Param based on provided data.
@@ -62,5 +65,5 @@
 	 *             when Param getType is not defined
 	 */
-	public Param build()  {
+	public Param finish()  {
 		assert param != null;
 		param.id = id;
@@ -73,5 +76,5 @@
 	}
 
-	public ParamBuilder setId(String id) {
+	public ParamBuilder id(String id) {
 		this.id = id;
 		return this;
@@ -87,16 +90,14 @@
 	}
 
-	public <T extends Param> ParamBuilder setType(Class<T> type) {
+	public <T extends Param> ParamBuilder type(Class<T> type) {
 		try {
 			return internalSetType(type, type.newInstance());
-		} catch (InstantiationException e) {
+		} catch (InstantiationException | IllegalAccessException e) {
 			e.printStackTrace();
-		} catch (IllegalAccessException e) {
-			e.printStackTrace();
-		}
-		return this;
-	}
-
-	public <T extends Param> ParamBuilder setType(T param) {
+		}
+		return this;
+	}
+
+	public <T extends Param> ParamBuilder type(T param) {
 		return internalSetType(param.getClass(), param);
 	}
@@ -108,15 +109,15 @@
 	}
 
-	public ParamBuilder setGroup(Integer group) {
+	public ParamBuilder group(Integer group) {
 		this.group = group;
 		return this;
 	}
 
-	public ParamBuilder setFlags(Integer flags) {
+	public ParamBuilder flags(Integer flags) {
 		this.flags = flags;
 		return this;
 	}
 
-	public ParamBuilder setName(String name) {
+	public ParamBuilder name(String name) {
 		this.name = name;
 		return this;
@@ -142,5 +143,5 @@
 	}
 
-	public ParamBuilder setType(String type) {
+	public ParamBuilder type(String type) {
 
 		log.trace("parsing type: " + type);
@@ -153,5 +154,5 @@
 		switch (first.charAt(0)) {
 			case 'o': {
-				setType(new ObjectParam(second != null ? second : first.substring(1)));
+				type(new ObjectParam(second != null ? second : first.substring(1)));
 				break;
 			}
@@ -164,5 +165,5 @@
 					log.error("invalid procedure signature '" + signature + "': " + e);
 				}
-				setType(procedureParam);
+				type(procedureParam);
 				break;
 			}
@@ -171,23 +172,27 @@
 				int tildeIndex = type.indexOf("~");
 				if (tildeIndex != -1) {
-					setType(new EnumParam(new ArrayList<String>(Arrays.asList(type.substring(tildeIndex + 1).split("~")))));
+					type(new EnumParam(new ArrayList<String>(Arrays.asList(type.substring(tildeIndex + 1).split("~")))));
 				} else {
 					if (first.length() >= 2) {
-				switch (first.charAt(1)) {
+						switch (first.charAt(1)) {
 							case 'b': {
-								setType(BinaryParam.class);
+								type(BinaryParam.class);
 								break;
 							}
 							case 'c': {
-								setType(ColorParam.class);
+								type(ColorParam.class);
 								break;
+							}
+							default: {
+								log.error("unknown type: " + first);
+								return this;
 							}
 						}
 					}
 					if ("0".equals(second) && "1".equals(third)) {
-						setType(BooleanParam.class);
+						type(BooleanParam.class);
 					}
 					if (param == null) {
-						setType(DecimalParam.class);
+						type(DecimalParam.class);
 					}
 				}
@@ -198,32 +203,35 @@
 			}
 			case 'f': {
-				setType(FloatParam.class);
+				type(FloatParam.class);
 				parseMinMaxDefNumber(Double.class, second, third);
 				break;
 			}
 			case 'x': {
-				setType(UniversalParam.class);
+				type(UniversalParam.class);
 				break;
 			}
 			case 's': {
-				setType(StringParam.class);
-				setMin(second);
-				setMax(third);
+				type(StringParam.class);
+				min(second);
+				max(third);
 				break;
 			}
 			case 'e': {
-				setType(EventParam.class);
+				type(EventParam.class);
 				break;
 			}
 			case 'l': {
-				setType(third != null ? new UniqueListParam(second, third) : new ArrayListParam(second));
-				break;
-			}
-
-		}
-		return this;
-	}
-
-	public ParamBuilder setHelp(String help) {
+				type(third != null ? new UniqueListParam(second, third) : new ArrayListParam(second));
+				break;
+			}
+			default:{
+				log.error("unknown type: " + first);
+				return this;
+			}
+		}
+		return this;
+	}
+
+	public ParamBuilder help(String help) {
 		this.help = help;
 		return this;
@@ -237,5 +245,5 @@
 	}
 
-	public <T> ParamBuilder setMin(T min) {
+	public <T> ParamBuilder min(T min) {
 		if (primitiveParam != null) {
 			this.primitiveParam.min = min;
@@ -244,5 +252,5 @@
 	}
 
-	public <T> ParamBuilder setMax(T max) {
+	public <T> ParamBuilder max(T max) {
 		if (primitiveParam != null) {
 			this.primitiveParam.max = max;
@@ -251,5 +259,5 @@
 	}
 
-	public <T> ParamBuilder setDef(T def) {
+	public <T> ParamBuilder def(T def) {
 		if (def != null && primitiveParam != null) {
 			this.primitiveParam.def = def;
@@ -277,10 +285,10 @@
 
 		try {
-			setId(paramEntryValues[0]);
-			setGroup(Integer.valueOf(paramEntryValues[1]));
-			setFlags(Flags.read(paramEntryValues[2]));
-			setName(paramEntryValues[3]);
-			setType(paramEntryValues[4]);
-			setHelp(paramEntryValues[6]);
+			id(paramEntryValues[0]);
+			group(Integer.valueOf(paramEntryValues[1]));
+			flags(Flags.read(paramEntryValues[2]));
+			name(paramEntryValues[3]);
+			type(paramEntryValues[4]);
+			help(paramEntryValues[6]);
 		} catch (IndexOutOfBoundsException e) {
 			/** everything is ok, parameters have just finished*/
@@ -290,20 +298,30 @@
 			return null;
 		}
-		return build();
+		return finish();
 	}
 
 	public void setField(String key, String value) {
-		if (key.equals(ID_FIELD)) {
-			setId(value);
-		} else if (key.equals(NAME_FIELD)) {
-			setName(value);
-		} else if (key.equals(TYPE_FIELD)) {
-			setType(value);
-		} else if (key.equals(FLAGS_FIELD)) {
-			setFlags(Flags.read(value));
-		} else if (key.equals(HELP_FIELD)) {
-			setHelp(value);
-		} else if (key.equals(GROUP_FIELD)) {
-			setGroup(Integer.valueOf(value));
+		switch (key) {
+			case ID_FIELD:
+				id(value);
+				break;
+			case NAME_FIELD:
+				name(value);
+				break;
+			case TYPE_FIELD:
+				type(value);
+				break;
+			case FLAGS_FIELD:
+				flags(Flags.read(value));
+				break;
+			case HELP_FIELD:
+				help(value);
+				break;
+			case GROUP_FIELD:
+				group(Integer.valueOf(value));
+				break;
+			default:
+				log.error("unknown field for Param: " + key);
+				break;
 		}
 	}
@@ -312,9 +330,10 @@
 	public static FramsClass getFramsClass() {
 		return new FramsClass("prop", "prop", null)
-				.append(new ParamBuilder().setId("name").setName("Name").setType(StringParam.class).build())
-				.append(new ParamBuilder().setId("id").setName("Id").setType(StringParam.class).build())
-				.append(new ParamBuilder().setId("type").setName("Type").setType(StringParam.class).build())
-				.append(new ParamBuilder().setId("help").setName("Help").setType(StringParam.class).build())
-				.append(new ParamBuilder().setId("flags").setName("Flags").setType(DecimalParam.class).build());
+			.append(Param.build().id("name").name("Name").type(StringParam.class))
+			.append(Param.build().id("id").name("Id").type(StringParam.class))
+			.append(Param.build().id("type").name("Type").type(StringParam.class))
+			.append(Param.build().id("help").name("Help").type(StringParam.class))
+			.append(Param.build().id("group").name("Group").type(DecimalParam.class))
+			.append(Param.build().id("flags").name("Flags").type(DecimalParam.class));
 	}
 
Index: java/main/src/main/java/com/framsticks/params/PropertiesAccess.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/PropertiesAccess.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/params/PropertiesAccess.java	(revision 85)
@@ -40,13 +40,16 @@
 		assert properties != null;
 		assert param != null;
-		Object object = null;
+		Object object = properties.get(param.getId());
+		if (object != null) {
+			try {
+				return type.cast(object);
+			} catch (ClassCastException e) {
+				throw (ClassCastException) new ClassCastException("property " + param + " type is " + object.getClass().getName() + ", not " + type.getName()).initCause(e);
+			}
+		}
 		try {
-			object = properties.get(param.getId());
-			if (object == null) {
-				return param.getDef(type);
-			}
-			return type.cast(object);
+			return param.getDef(type);
 		} catch (ClassCastException e) {
-			throw new ClassCastException("property " + param.getId() + " type is " + object.getClass().getName() + ", not " + type.getName());
+			throw (ClassCastException) new ClassCastException("default value of property " + param + " is not of type " + type.getName()).initCause(e);
 		}
 
Index: java/main/src/main/java/com/framsticks/params/ReflectionAccess.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/ReflectionAccess.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/params/ReflectionAccess.java	(revision 85)
@@ -47,13 +47,16 @@
 			try {
 				return type.cast(reflectedClass.getMethod(accessorName(true, id)).invoke(object));
-			} catch (NoSuchMethodException ex) {
-				//ex.printStackTrace();
-			} catch (InvocationTargetException e) {
+			} catch (NoSuchMethodException | InvocationTargetException ex) {
+				//e.printStackTrace();
+			}
+			try {
+				return type.cast(reflectedClass.getMethod(id).invoke(object));
+			} catch (NoSuchMethodException | InvocationTargetException ex) {
 				//e.printStackTrace();
 			}
 
-		} catch (IllegalAccessException ex) {
+		} catch (IllegalAccessException e) {
 			log.warn("illegal access error occurred while trying to access returnedObject");
-			ex.printStackTrace();
+			e.printStackTrace();
 		} catch (ClassCastException ignored) {
 
@@ -87,6 +90,9 @@
 			try {
 				reflectedClass.getMethod(accessorName(false, id), new Class[]{param.getStorageType()}).invoke(object, value);
-			} catch (InvocationTargetException ignored) {
-			} catch (NoSuchMethodException ignored) {
+			} catch (InvocationTargetException | NoSuchMethodException ignored) {
+			}
+			try {
+				reflectedClass.getMethod(id, new Class[]{param.getStorageType()}).invoke(object, value);
+			} catch (InvocationTargetException | NoSuchMethodException ignored) {
 			}
 		} catch (Exception ex) {
@@ -161,7 +167,5 @@
 		try {
 			return reflectedClass.newInstance();
-		} catch (InstantiationException e) {
-			e.printStackTrace();
-		} catch (IllegalAccessException e) {
+		} catch (InstantiationException | IllegalAccessException e) {
 			e.printStackTrace();
 		}
